#ifndef SORTIERENCONCEPT_H
#define SORTIERENCONCEPT_H
#include <concepts>

/*
template<typename T>
concept Sortierbar = requires(T c) {
   c[0] < c[0]  ;          // vergleichbar, []-Operator und
   c.begin() + 1 ;         // Random Access
};
*/

// alternativ nur mit std::random_access_iterator
template<typename C>
concept Sortierbar = std::random_access_iterator<typename C::iterator>;  // OK

//template <Sortierbar T> void sortieren( T& c) // alternativ
void sortieren(Sortierbar auto& c) 
{
  for (auto i{0}; i < std::ssize(c); ++i) {
    for (auto j = i; j < std::ssize(c); ++j) {
      if (c[i] > c[j]) {                     // Zugriff mit []
        auto temp = c[i];
        c[i] = c[j];
        c[j] = temp;
      }
    }
  }
}
#endif
