#include <iostream>
#include <thread>
#include <chrono>
#include "Generator.h"

Generator<int> fibonaccizahlen(int anzahl) 
{ 
  // Die ersten zwei Zahlen sind 1. Jede weitere Zahl ist die Summe ihrer beiden Vorgänger.
  int v1 {0};
  int v2 {1};
  for(int i = 0; i < anzahl; ++i) {
    // lange Berechnungszeit simulieren
    std::this_thread::sleep_for(std::chrono::milliseconds(500));
    auto temp = v1;
    v1 = v2;
    v2 += temp;
    co_yield v1;
  }
}

int main() 
{
  auto g = fibonaccizahlen(10);
  int i {0};
  while(g.resume()) {
    std::cout << ++i << ": " << g.current_value() << '\n';
  }
}
