#include <iostream>

auto fakultaet0(int zahl)                       // nicht constexpr
{
  long long fak{1uL};
  while (zahl > 1) {
    fak *= zahl--;
  }
  return fak;
}

constexpr long long fakultaet1(int zahl)        // constexpr
{
  return zahl < 2 ? 1 : zahl * fakultaet1(zahl - 1);
}

auto getWert()                                  //  nicht-constexpr
{
  return 3u; 
}

int main()
{
  const auto erg0{fakultaet0(3)};               // const, aber nicht constexpr
  std::cout << "Ergebnis = " << erg0 << '\n';

  // constexpr-Funktion liefert nicht-constexpr Wert
  int zahl {4u};                                // kein const
  auto erg1 {fakultaet1(zahl)};
  std::cout << "Ergebnis = " << erg1 << '\n';

  // constexpr-Funktion liefert nicht-constexpr Wert
  const auto czahl1{getWert()};                 // nicht mit constexpr initialisiert
  auto erg2{fakultaet1(czahl1)};
  std::cout << "Ergebnis = " << erg2 << '\n';

  // constexpr-Funktion liefert constexpr Wert
  const int czahl2{3};                          // 3 ist Literal
  constexpr auto erg3{fakultaet1(czahl2)};
  std::cout << "Ergebnis = " << erg3 << '\n';

  // constexpr-Funktion liefert constexpr Wert
  constexpr auto erg4{fakultaet1(3)};           // 3 ist Literal
  std::cout << "Ergebnis = " << erg4 << '\n';
}

