#include <algorithm>
#include <cstdlib>                           // abs()
#include <iostream>
#include <showContainer.h>
#include <vector>

using namespace std;

int main()
{
  vector<int> folge{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
  cout << "Folge = ";
  showContainer(folge);
  vector<int> teilfolge(folge.begin() + 5,
                        folge.begin() + 9);          // 5 6 7 8
  cout << "Teilfolge = ";
  showContainer(teilfolge);
  // Teilfolge in Folge suchen
  auto iter = ranges::search(folge, teilfolge).begin();
  if (iter != folge.end()) {
    cout << " Die Teilfolge ist in der Folge ab Position " 
         << (iter - folge.begin()) << " enthalten.\n";
  }
  else {
    cout << "Die Teilfolge ist nicht in der Folge enthalten.\n";
  }
  // Fall2: binäres Prädikat. Dafür negative Zahlen setzen
  for (auto& el : teilfolge) {
    el = -el;          // -5 -6 -7 -8
  }
  cout << "Teilfolge = ";
  showContainer(teilfolge);
  // Teilfolge in Folge suchen, dabei Vorzeichen ignorieren
  iter = ranges::search(folge, teilfolge,
                        [](int x, int y) { return abs(x) == abs(y); }).begin();
  if (iter != folge.end()) {
    cout << " Die Teilfolge ist in der Folge ab Position " 
         << (iter - folge.begin())
         << " enthalten. Vorzeichen wurden ignoriert.\n";
  }
  else {
    cout << "Die Teilfolge ist nicht in der Folge enthalten.\n";
  }
}

