#include <algorithm>
#include <iostream>
#include <iterator>
#include <string>

int main()
{
  // String mit vielen zu eliminierenden Leerzeichen und Punkten
  const std::string str { "Guten      Morgen, liebe    Sorgen..." };
  std::cout << str << '\n';
  // Variante 1: Speicherplatz bereitstellen und überflüssige Zeichen anschließend löschen
  std::string erg1 = str;
  auto [lastvalid, last] = std::ranges::unique_copy(str, erg1.begin());
  erg1.erase(last, erg1.end());
  std::cout << erg1 << '\n';
  // Variante 2: Nur den benötigten Platz beanspruchen, erase() entfällt
  std::string erg2;
  std::unique_copy(str.begin(), str.end(), std::back_inserter(erg2));
  std::cout << erg2 << '\n';
}
