#include <Random.h>
#include <algorithm>
#include <cmath>                             // fabs()
#include <showContainer.h>
#include <vector>
using namespace std;

int main()
{
  vector<double> v1(8);
  vector<double> v2(8);
  Random zufall(100);
  for (int i = 0; i < ssize(v1); ++i) {
    v1[i] = i + zufall() / 10000.0;
    v2[i] = i + zufall() / 10000.0;
  }
  showContainer(v1);          // Anzeige
  showContainer(v2);

  // Prüfung auf einen Schwellenwert 0.01 mit Iterator Paar wo:
  auto wo = ranges::mismatch(v1, v2, 
                          [](auto x, auto y) { return fabs(x - y) < 0.01; });
  if (wo.in1 == v1.end()) {
    cout << "Inhalt der Container stimmt innerhalb der Toleranz überein.\n";
  }
  else {
    cout << "Der erste Unterschied (" << *wo.in1 << " != "
         << *wo.in2 << ") wurde an Position "
         << (wo.in1 - v1.begin()) << " gefunden.\n";
  }
}

