#include <iostream>

void tabellenausgabe2D(int (*T)[3], int n)
{
  // alternativ: void tabellenausgabe(int T[][3], int n)
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < 3; ++j) {
      std::cout << T[i][j] << ' ';
    }
    std::cout << '\n';
  }
  std::cout << '\n';
}

template <typename Feldtyp> 
void tabellenausgabe2DT(Feldtyp tabelle, int zeilen)  // int (*)[3]
{
  constexpr int spalten{sizeof tabelle[0] / sizeof tabelle[0][0]};
  for (int i = 0; i < zeilen; ++i) {
    for (int j = 0; j < spalten; ++j) {
      std::cout << tabelle[i][j] << ' ';
    }
    std::cout << '\n';
  }
  std::cout << '\n';
}

template <typename Feldtyp>
void tabellenausgabe2DT(Feldtyp& tabelle)          // int [2][3]
{ 
  constexpr int zeilen{sizeof(Feldtyp) / sizeof(tabelle[0])};
  constexpr int spalten{sizeof tabelle[0] / sizeof tabelle[0][0]};
  for (int i = 0; i < zeilen; ++i) {
    for (int j = 0; j < spalten; ++j) {
      std::cout << tabelle[i][j] << ' ';
    }
    std::cout << '\n';
  }
  std::cout << '\n';
}

// Mit statischer Information über Zeilen und Spalten
template<typename Elementtyp, int zeilen, int spalten>
void tabellenausgabe2DTx(const Elementtyp(&tabelle)[zeilen][spalten]) {
  for (int i = 0; i < zeilen; ++i) {
    for (int j = 0; j < spalten; ++j) {
      std::cout << tabelle[i][j] << ' ';
    }
    std::cout << '\n';
  }
  std::cout << '\n';
}

int main()
{
  int feld1[][3] = {{1, 2, 3}, {4, 5, 6}};
  tabellenausgabe2D(feld1, 2);
  // Templates
  tabellenausgabe2DT(feld1, 2);
  tabellenausgabe2DT(feld1);
  tabellenausgabe2DTx(feld1);
}
