#include "Meinstring.h"
#include <cassert>
#include <cstring>          // strlen()

/* Der allgemeine Konstruktor erzeugt aus einem klassischen C-String
ein
\tt{MeinString}-Objekt.
*/

MeinString::MeinString(const char* s)          // allg. Konstruktor
  : daten(s, s + std::strlen(s) + 1)           // +1 wg Nullbyte
{ }

MeinString& MeinString::assign(const char* s)  // Zuweisung eines C-Strings
{
  MeinString temp(s);          // Objekt ausreichender Größe schaffen
  swap(temp);                  // vertauschen
  return *this;
}

char& MeinString::at(int position)       // Zeichen per Referenz holen
{
  assert(position < length());          // Nullbyte lesen ist nicht erlaubt
  return daten[position];
}

const char& MeinString::at(int position) const  // Zeichen holen
{
  assert(position < length());          // Nullbyte lesen ist nicht erlaubt
  return daten[position];
}

void MeinString::swap(MeinString& mString)
{
  std::swap(daten, mString.daten);          // Bibliotheksfunktion
}

void anzeigen(std::ostream& os, const MeinString& m) { os << m.data(); }
