#include <iostream>
using namespace std;

class Fahrzeug {
public:                              // öffentlich
  Fahrzeug(int r) : radZahl(r) {}
  int anzahlRaeder() const           // Methode
  {
    return radZahl;
  }
private:                             // Zugriff von außerhalb der Klasse nicht erlaubt
  int radZahl = 0;                   // Attribut (0 bedeute undefiniert)
};

class Fahrrad : public Fahrzeug {    // von Fahrzeug erben
public:
  Fahrrad() : Fahrzeug(2) {}         // Initialisierung des Oberklassenattributs
};
     
class Auto : public Fahrzeug {        // von Fahrzeug erben
public:
  Auto(double verbr) 
    : Fahrzeug(4),                    // Initialisierung des Oberklassenattributs
      verbrauch(verbr)                // und des eigenen Attributs
  {}
  /* Eigene Methode, um Besonderheiten der Klasse zu berücksichtigen. Bitte beachten
     Sie, dass hier nur eine Besonderheit in möglichst einfacher Form demonstriert
     wird, denn so verschiedene Dinge wie  die Ausgabe und die Rückgabe eines Werts
     sollen normalerweise nicht in einer einzigen Funktion  verquickt werden!  */
  int anzahlRaeder() const            // verdeckt Fahrzeug::anzahlRaeder()
  {
    cout << "Auto: ";                 // >>Besonderheit<< dieser Klasse 
    return Fahrzeug::anzahlRaeder();  // Aufruf der Oberklassenmethode
  }
  double spritverbrauch() const
  { 
    return verbrauch; 
  }
private:
  double verbrauch;
};

int main()
{
  Fahrrad einFahrrad;
  cout << einFahrrad.anzahlRaeder() << '\n';
  Auto einAuto(6.8);
  cout << einAuto.anzahlRaeder() << '\n';
  cout << einAuto.spritverbrauch() << '\n';
}

