#ifndef A_H
#define A_H
#include <algorithm>                        // swap()
#include <iostream>
#include <memory>                           // unique_ptr()
#include <typeinfo>

class A {
public:
  explicit A(int a_) 
    : a{a_} 
  {}
  virtual ~A() = default;
  A(const A&) = delete;
  A& operator=(const A&) = delete;
  A(A&&) = delete;
  A& operator=(A&&) = delete;

  virtual std::unique_ptr<A> clone() const
  {
    std::cout << "virtual A* A::clone()\n";
    return std::make_unique<A>(a);
  }

  virtual void ausgabe() const { std::cout << "A.a = " << a << ' '; }

  bool operator==(const A& arg) const
  {
    std::cout << "A::operator==(const A& arg)\n";
    return isEqual(arg);
  }
protected:
  auto get() const { return a; }
  virtual bool isEqual(const A& arg) const
  {
    std::cout << "A::isEqual(const A& arg)\n";
    return a == arg.a;
  }

private:
  int a;
};
#endif

