#ifndef MATRIX3D_T
#define MATRIX3D_T
#include <iostream>
#include "Matrix.t"

template <typename T> 
class Matrix3d {
public:
  Matrix3d(int x = 1, int y = 1, int z = 1, const T& init = T()) 
    : daten(x, Matrix<T>(y, z, init)) 
  { }
  int dim1() const { return daten.size(); } 
  int dim2() const { return daten[0].zeilen(); } 
  int dim3() const { return daten[0][0].size(); } 

  auto& operator[](int x) { return daten[x]; }
  const auto& operator[](int x) const { return daten[x]; }

private:
  std::vector<Matrix<T>> daten;
};

template <typename T> 
void print(const Matrix3d<T>& m) 
{
  for (int i = 0; i < m.dim1(); ++i) {
    print(m[i]);                             // m[i] ist eine 2D-Matrix
  }
}
#endif

