#include <cmath>
#include <compare>
#include <iostream>
#include <typeinfo>

int main()
{
  std::cout << typeid(2.1 <=> 3.1).name() << '\n';
  std::cout << std::boolalpha
            << ( 2.1 <=> 3.1  < 0) << ' '
            << ( 3.1 <=> 2.1  > 0) << ' '
            << ( 2.1 <=> 2.1 == 0) << '\n';
  constexpr double NaN {NAN};
  std::cout << std::boolalpha
            << ( NaN <=> 2.1  < 0) << ' '
            << ( NaN <=> 2.1  > 0) << ' '
            << ( NaN <=> 2.1 == 0) << ' '
            << ( NaN <=> NaN == 0) << '\n';
  static_assert(std::partial_ordering::less       == 2.1 <=> 3.1);
  static_assert(std::partial_ordering::greater    == 3.1 <=> 2.0);
  static_assert(std::partial_ordering::equivalent == 3.1 <=> 3.1);
  static_assert(std::partial_ordering::unordered  == NaN <=> NaN);
  static_assert(NaN != NaN);
}
